# Performing Data Analysis

The first problem to tackle is how to narrow down the number of companies that would be fundamentally sound enough to invest in. To do this, we need to answer the following questions:

- Is the company making a profit
- Are the company's sales growing
- How is the future outlook of the company?
- How are economic changes going to impact the growth scenario of the company?

To begin processing the data we will be using

!!! question "TODO"
   Figure out what library to use

## Weed Out

There are over 5000 companies traded publicly traded, but performing analysis on them all might be somewhat excessive. The first criteria to remove the following:

- Companies not making a profit
- Companies that have a risky level of debt

From here, you can perform sector analysis on companies to determine outliers. What are normal sales ratios, etc.

## Metrics

There are a variety of metrics we can then look at for further scrutiny:

- Debt/Equity Ratio
- P/B Ratio (price to book ratio)
- P/E (price-to-earnings ratio)
- Profit Margins
- ROE Ratio (return on equity)
<!-- add more -->

## The Fed

- Evaluate interest rate risk
- Evaluate the bond market
- Look at the yield curve
- Look at the Consumer Price Index
- Look at inflation, present and forecast

## Scoring

We can then apply a scoring methodology that weights companies based on a variety of metrics and use it to gauge investment risk.
